<template>
  <section class="schedule">
    <slot name="title"/>

    <schedule-row v-for="(item, index) in scheduleItems"
                  :key="index"
                  :rowInfo="item"
                  :schedule="scheduleRules"
                  :scheduleItems="scheduleItems"
                  :minMaxTimes="minMaxTimes"
                  :minDuration="minDuration"
                  :quantise="quantise"
                  :noOwnBookings="noOwnBookings"
                  @saveRow="saveRow"
                  @removeRow="removeRow"
                  @changeTime="onChangeTime"
                  @changeDate="onChangeDate"
                  @changePrice="onChangePrice"
                  @changeVisitors="onChangeVisitors"
                  :getNoWorkingHours="getNoWorkingHours"
                  :selectWithVisitors="selectWithVisitors"
    />

    <schedule-row v-if="isNewItemShown"
                  :rowInfo="newItemTemplate"
                  :schedule="scheduleRules"
                  :scheduleItems="scheduleItems"
                  :minMaxTimes="minMaxTimes"
                  :minDuration="minDuration"
                  :quantise="quantise"
                  :noOwnBookings="noOwnBookings"
                  @saveRow="saveRow"
                  @removeRow="removeRow"
                  @changeTime="onChangeTime"
                  @changeDate="onChangeDate"
                  @changePrice="onChangePrice"
                  @changeVisitors="onChangeVisitors"
                  :getNoWorkingHours="getNoWorkingHours"
                  :selectWithVisitors="selectWithVisitors"
    />

    <button type="button" class="schedule__btn button button--gray"
            v-if="!isNewItemShown"
             @click="addRow">
      <icon-plus />
      <template v-if="scheduleItems.length">
        Забронировать еще
      </template>
      <template v-else>
        Указать время
      </template>

    </button>

  </section>
</template>

<script>
  import { mapActions, mapGetters } from 'vuex';

  import ScheduleRow from './ScheduleRow';
  import IconPlus from './icons/IconPlus';
  import {getFloatTime} from "assets/js/helpers/formatTime";

  export default {
    name: 'Schedule',
    components: {
      IconPlus,
      ScheduleRow
    },
    props: {
      scheduleRules: {
        type: Array,
        required: true,
      },

      minMaxTimes: {
        type: Object,
        required: true
      },

      minDuration: {
        type: String,
        required: true
      },

      quantise: {
        type: String,
        required: true
      },

      roomId: {
        type: [Number, String],
        required: true
      },

      bookings: {
        type: [Array],
        required: true,
      },

      noOwnBookings: {
        type: Array,
        required: true
      },

      getNoWorkingHours: {
        type: Function,
        required: true
      },

      selectWithVisitors: {
        type: Function,
        required: true
      }
    },
    data: () => ({
      newItemTemplate: {
        bookingId: 'new',
        isOpen: true,
        date: '',
        timeFrom: '',
        timeTo: '',
        price: null,
        price_old: null,
        visitors: null
      },
      isNewItemShown: false,
      isAllRowsClosed: false,
    }),
    computed: {
      ...mapGetters({
        isAuthenticated: 'auth/isAuthenticated'
      }),

      scheduleItems() {
        const currentBookings = this.$store.state.schedule.bookings.filter((booking) => booking.roomId === this.roomId)[0];
        if (!currentBookings) return [];

        return currentBookings.bookingItems.filter((booking) => !booking.ordered);
      },
    },
    methods: {
      ...mapActions({
        addBooking: 'schedule/addBooking',
        removeBooking: 'schedule/removeBooking',
        editBooking: 'schedule/editBooking'
      }),

      saveRow() {
        this.isNewItemShown = false;

        this.addBooking({
          roomId: this.roomId,
          booking: {
            date: this.newItemTemplate.date,
            timeFrom: this.newItemTemplate.timeFrom,
            timeTo: this.newItemTemplate.timeTo,
            visitors: this.newItemTemplate.visitors
          }
        })
      },

      removeRow(id) {
        if (id === 'new') {
          this.isNewItemShown = false;
        } else {
          this.removeBooking({ roomId: this.roomId, bookingId: id })
        }
      },

      addRow() {
        if (!this.isAuthenticated) {
          this.$router.push({ path: `/login`, query: {
            [this.$route.name === 'checkout-id' ? 'checkout' : 'place']: this.roomId
          }});

          return;
        }

        if (!this.isNewItemShown) {
          this.newItemTemplate = {
            bookingId: 'new',
            isOpen: true,
            date: '',
            timeFrom: '',
            timeTo: '',
            price: null,
            price_old: null,
            visitors: null
          };
        }

        this.isNewItemShown = true;
      },

      onChangeTime(event) {
        if (event.id === 'new') {

          if (event.type === 'from') {
            this.newItemTemplate.timeFrom = event.value;

            if ((this.newItemTemplate.timeTo !== '') && this.newItemTemplate.date && this.newItemTemplate.visitors === null) {
              this.newItemTemplate.visitors = this.selectWithVisitors(event.value.value, this.newItemTemplate.timeTo.value, this.newItemTemplate.date, {index: 0})
            }
          } else {
            this.newItemTemplate.timeTo = event.value;

            if ((this.newItemTemplate.timeFrom !== '') && this.newItemTemplate.date && this.newItemTemplate.visitors === null) {
              this.newItemTemplate.visitors = this.selectWithVisitors(this.newItemTemplate.timeFrom.value, event.value.value, this.newItemTemplate.date, {index: 0})
            }
          }

        } else {

          if (event.type === 'from') {
            let { date, timeTo, timeFrom, visitors } = this.scheduleItems.filter((item) => item.bookingId === event.id)[0];
            visitors = this.selectWithVisitors(event.value.value, timeTo.value, date) !== null ? !visitors ? this.selectWithVisitors(event.value.value, timeTo.value, date, {index: 0}) : visitors : null

            if (timeFrom.value === event.value.value) return;

            this.editBooking({
              roomId: this.roomId,
              bookingId: event.id,
              bookingInfo: {
                timeFrom: event.value,
                date, timeTo, visitors
              }
            })
          } else {
            let { date, timeTo, timeFrom, visitors } = this.scheduleItems.filter((item) => item.bookingId === event.id)[0];
            visitors = this.selectWithVisitors(timeFrom.value, event.value.value, date) !== null ? !visitors ? this.selectWithVisitors(event.value.value, timeTo.value, date, {index: 0}) : visitors : null

            if (timeTo.value === event.value.value) return;

            this.editBooking({
              roomId: this.roomId,
              bookingId: event.id,
              bookingInfo: {
                timeTo: event.value,
                date, timeFrom, visitors
              }
            })
          }

        }
      },

      onChangeVisitors(event) {

        if (event.id === 'new') {
          this.newItemTemplate.visitors = event.value
        } else {
          const { timeFrom, timeTo, date } = this.scheduleItems.filter((item) => item.bookingId === event.id)[0];

          this.editBooking({
            roomId: this.roomId,
            bookingId: event.id,
            bookingInfo: {
              date, timeFrom, timeTo,
              visitors: event.value
            }
          })
        }
      },


      onChangeDate(event) {
        if (event.id === 'new') {
          this.newItemTemplate.date = event.value
        } else {
          const { timeFrom, timeTo, date, visitors } = this.scheduleItems.filter((item) => item.bookingId === event.id)[0];

          if (Number(date) === Number(event.value)) return;

          this.editBooking({
            roomId: this.roomId,
            bookingId: event.id,
            bookingInfo: {
              date: event.value,
              timeFrom, timeTo, visitors
            }
          })
        }
      },

      onChangePrice(event) {
        if (event.id === 'new') {
          this.newItemTemplate.price = event.price;
        }
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .schedule {
    &__top-row {
      display: flex;
      align-items: center;
      justify-content: space-between;
      margin-bottom: rem(8);
    }

    &__arrow {
      @include to-top-arrow;
    }

    &__title {
      @include h4;
    }

    &__btn {
      margin-top: rem(28);
      padding-left: rem(28);
      padding-right: rem(36);

      svg {
        width: rem(12);
        height: rem(12);
        margin-right: rem(10);
      }
    }
  }
</style>
